import _createGenerateClassName from "@material-ui/core/styles/createGenerateClassName";
import _SheetsRegistry from "jss/lib/SheetsRegistry";
import _createMuiTheme from "@material-ui/core/styles/createMuiTheme";

function createContext(themeObj) {
  return {
    theme: _createMuiTheme(themeObj),
    // eslint-disable-next-line no-undef
    sheetsManager: new Map(),
    // This is needed in order to inject the critical CSS.
    sheetsRegistry: new _SheetsRegistry(),
    // The standard class name generator.
    generateClassName: _createGenerateClassName()
  };
}

let pageContext;
export default function getContext(themeObj) {
  // Make sure to create a new store for every server-side request so that data
  // isn't shared between connections (which would be bad)
  if (!process.browser) {
    return createContext(themeObj);
  } // Reuse context on the client-side


  if (!pageContext) {
    pageContext = createContext(themeObj);
  }

  return pageContext;
}